/* GCC */

#include <fstream>
#include <complex>
#include <vector>
#include <list>

typedef std::complex<int> Point;

struct Cmp
{
    Point* origin;
    Cmp(Point* o)
    {
        origin = o;
    }
    bool operator()(const std::pair<Point,int>& p1,const std::pair<Point,int>& p2)
    {
        return (p1.first.imag() - origin->imag()) * (p2.first.real() - origin->real()) <
               (p2.first.imag() - origin->imag()) * (p1.first.real() - origin->real());
    }
};

void solve(std::vector<std::pair<Point,int> >& point,int left,int right,std::list<std::pair<int,int> >& answer)
{
    if(left > right)
        return;
    for(int i = left+1;i <= right;i++)
        if(point[left].first.real() > point[i].first.real())
            std::swap(point[left],point[i]);
    std::sort(point.begin() + left + 1,point.begin() + right + 1,Cmp(&point[left].first));
    int blue = 0;
    int red = 0;
    int step;
    for(int i = left + 1;i <= right;i++)
    {
        if((2*point[i].second / point.size() != 2*point[left].second / point.size()) &&
           (blue == red))
        {
            step = i;
            break;
        }
        if(2*point[i].second / point.size())
            red++;
        else
            blue++;
    }
    if(2*point[step].second / point.size())
        answer.push_back(std::make_pair(point[left].second,point[step].second));
    else
        answer.push_back(std::make_pair(point[step].second,point[left].second));
    solve(point,left + 1,step - 1,answer);
    solve(point,step + 1,right,answer);
}

int main()
{
    std::ifstream in("pairs.in");
    std::ofstream out("pairs.out");
    int t,n;
    in >> t;
    for(int _ = 0;_ < t;_++)
    {
        in >> n;
        std::vector<std::pair<Point,int> > point(2*n);
        for(int i = 0;i < point.size();i++)
        {
            int x,y;
            in >> x >> y;
            point[i] = std::make_pair(Point(x,y),i);
        }
        std::list<std::pair<int,int> > answer;
        solve(point,0,point.size() - 1,answer);
        for(std::list<std::pair<int,int> >::iterator i = answer.begin();i != answer.end();i++)
            out << (i->first % (point.size()/2)) + 1 << ' ' << (i->second % (point.size()/2)) + 1 << '\n';
    }
    in.close();
    out.close();
}
