/* GCC */
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 5200;

enum{blue = 1 , red = 2};

struct Point
{
    int x , y , id , color;
    Point(){};
    Point(int _x , int _y , int _id , int _color) : x(_x) , y(_y) , id(_id) , color(_color) {};
} Pt[NMAX] , base;

bool cmp(Point u , Point v)
{
    return (u.y - base.y) * (v.x - base.x) < (v.y - base.y) * (u.x - base.x);
};

void F(int L , int R)
{
  if ( L > R )
    return;
  int min_id = L;
  for (int i = L + 1 ; i <= R ; i ++ )
    if ( Pt[i].y < Pt[min_id].y || (Pt[i].y == Pt[min_id].y && Pt[i].x < Pt[min_id].x) )
      min_id = i;

  swap(Pt[L] , Pt[min_id]);
  min_id = L;
  base = Pt[L];

  sort(Pt + L + 1 , Pt + R + 1 , cmp);

  int X = -1 , blue_cnt = 0 , red_cnt = 0;
  for (int i = L + 1 ; i <= R ; i ++ )
  {
    if ( Pt[i].color != Pt[L].color && blue_cnt == red_cnt )
    {
        X = i;
        if ( Pt[L].color == blue )
            printf("%d %d\n",Pt[L].id,Pt[X].id);
        else
            printf("%d %d\n",Pt[X].id,Pt[L].id);
        break;
    };
    if ( Pt[i].color == blue )
        blue_cnt ++ ;
    else
        red_cnt ++ ;
  };
  F(L + 1 , X - 1);
  F(X + 1 , R);
};
int main()
{
    freopen("pairs.in","r",stdin);
    freopen("pairs.out","w",stdout);
    int T;
    scanf("%d",&T);
    for ( ; T -- ; )
    {
        int N ;
        scanf("%d",&N);
        for (int i = 0 ; i < N ; i ++ )
        {
          int x , y ;
          scanf("%d %d",&x,&y);
          Pt[i] = Point(x , y , i + 1 , blue);
        };
        for (int i = 0 ; i < N ; i ++ )
        {
          int x , y ;
          scanf("%d %d",&x,&y);
          Pt[i + N] = Point(x , y , i + 1 , red);
        };
        F(0 , 2 * N - 1);
    };
    return 0;
}
