/* GCC */
#include <stdio.h>
#include <algorithm>
#include <vector>
using namespace std;

struct point{
       int color, id;
       int x, y;
       point(int x, int y): x(x), y(y){}
       point(){}
       bool operator < (point &p){ return x<p.x||(x==p.x && y < p.y);}
};

// Input
const int DEBUG = 0;
const char* in = "pairs.in";
const char* out = "pairs.out";
// Algorithm
point c, pts[5120];

bool comp(point a, point b){
     point x(a.x-c.x, a.y-c.y);
     point y(b.x-c.x, b.y-c.y);
     return (a.x*b.y)-(b.x*a.y) > 0;
}

void writeAns(const point &p1, const point &p2){
     if (p1.color == 1) printf("%d %d\n", p1.id+1, p2.id+1);
     else printf("%d %d\n", p2.id+1, p1.id+1);
}

void solve(int b, int e){
     if (b >= e) return;
     int best = b;
     for(int i = b; i < e; i++) if (pts[i] < pts[best]) best = i;
     swap(pts[b], pts[best]);
     c = pts[b];
     sort(pts+b+1, pts+e, comp);
     int divd = -1000000, sum = 0;
     for(int i = b; i < e; i++){
            sum += pts[i].color;
       if (sum == 0 && pts[i].color != pts[b].color && abs(i-(b+e)/2) < abs(divd-(b+e)/2)) divd = i;
     }
     writeAns(pts[b], pts[divd]);
     solve(b+1, divd);
     solve(divd+1, e);
}

int main(){
    if (!DEBUG) freopen(in, "r", stdin);
    if (!DEBUG) freopen(out, "w", stdout);
    int tests; scanf("%d", &tests);
    for(int t = 0; t < tests; t++){
        int points; scanf("%d", &points);
        for(int i = 0; i < points; i++){
          int x, y; scanf("%d %d", &x, &y);
          point p(x, y); p.color = 1; p.id = i;
          pts[i] = p;
        }
        for(int i = 0; i < points; i++){
          int x, y; scanf("%d %d", &x, &y);
          point p(x, y); p.color = -1; p.id = i;
          pts[i+points] = p;
        }
        solve(0, 2*points);
    }
    if (DEBUG) system("pause");
}
